public inbox for fstests@vger.kernel.org
 help / color / mirror / Atom feed
* [PATCH] generic/446: make sure all background processes are dead before umount
@ 2017-07-24 10:11 Eryu Guan
  2017-07-25  1:39 ` Xiao Yang
  2017-07-25  8:04 ` [PATCH v2] " Eryu Guan
  0 siblings, 2 replies; 8+ messages in thread
From: Eryu Guan @ 2017-07-24 10:11 UTC (permalink / raw)
  To: fstests; +Cc: yangx.jy, Eryu Guan

The $dread_pid refers to the while-true-do loop, wait for $dread_pid
doesn't mean the xfs_io direct read process is already dead,
sometimes xfs_io process is still running and blocking
_scratch_unmount.

Fix it by making the direct read does a fixed number of loop and
break out the second mmap-fpunch loop if the first loop exits. At
this point we're sure that there's no unfinished background process
blocking the umount.

Signed-off-by: Eryu Guan <eguan@redhat.com>
---
 tests/generic/446 | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

diff --git a/tests/generic/446 b/tests/generic/446
index 62ae449de6b1..83ff4ac9edd3 100755
--- a/tests/generic/446
+++ b/tests/generic/446
@@ -61,20 +61,22 @@ filesz=$((65536 * 2))
 $XFS_IO_PROG -f -c "truncate $((filesz * 2))" $SCRATCH_MNT/file >> $seqres.full
 
 # run a background dio read to a hole in a loop
-while true; do
+for i in `seq 0 999`; do
 	$XFS_IO_PROG -d -c "pread 0 $filesz" $SCRATCH_MNT/file > /dev/null 2>&1
 done &
 
 dread_pid=$!
 
 # run mapped write to the same hole as dio read
-for i in `seq 0 999`; do
+while true; do
 	$XFS_IO_PROG -c "mmap 0 $filesz" -c "mwrite 0 $filesz" $SCRATCH_MNT/file \
 		> /dev/null
 	$XFS_IO_PROG -c "fpunch 0 $filesz" $SCRATCH_MNT/file > /dev/null
+	if ! kill -s 0 $dread_pid >/dev/null 2>&1; then
+		break
+	fi
 done
 
-kill -9 $dread_pid > /dev/null 2>&1
 wait $dread_pid > /dev/null 2>&1
 
 echo "Silence is golden"
-- 
2.13.3


^ permalink raw reply related	[flat|nested] 8+ messages in thread

end of thread, other threads:[~2017-07-27  6:30 UTC | newest]

Thread overview: 8+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2017-07-24 10:11 [PATCH] generic/446: make sure all background processes are dead before umount Eryu Guan
2017-07-25  1:39 ` Xiao Yang
2017-07-25  6:31   ` Eryu Guan
2017-07-25  7:43     ` Xiao Yang
2017-07-25  7:50       ` Eryu Guan
2017-07-25  8:04 ` [PATCH v2] " Eryu Guan
2017-07-27  5:22   ` Eryu Guan
2017-07-27  6:30     ` Xiao Yang

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox